Educational Codeforces Round 166 (Rated for Div. 2) (A~C)

2024-06-03 02:28

本文主要是介绍Educational Codeforces Round 166 (Rated for Div. 2) (A~C),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

A. Verify Password

思路:按照ASCLL值进行比较就行(因为字母的ASCLL本来就在数字后面),所以,只要找到前面比后面的数大就输出NO,反之YES

代码实现:

#include<bits/stdc++.h>
using namespace std;
#define N 100005
typedef long long ll;
ll n, m, num, sum, t;
ll a[N], dp[N];
char s[N];
int main()
{cin >> t;while (t--){int flag = 0;cin >> n;cin >> s + 1;for (int i = 1; i < n; i++) {if (s[i] > s[i + 1]) {flag = 1;}}if (flag == 1)cout << "NO" << endl;elsecout << "YES" << endl;}return 0;
}


B. Increase/Decrease/Copy

思路:

因为对于前n项,我们并不会改变其位置,只有第n+1项,我们进行特判

对于a[i]->b[i],,转变的最小代价就是它们的差值。

对于b[n+1],得到它的最小代价就是a[i]->b[i]过程中与它最小的差值+1

实现代码:

#include<bits/stdc++.h>
using namespace std;
#define N 200005
typedef long long ll;
ll n, m, num, sum, t;
ll a[N], b[N];
char s[N];
int main()
{cin >> t;while (t--){int flag=0;num = 0;sum = 1e9;cin >> n;for (int i = 1; i <= n; i++) {cin >> a[i];}for (int i = 1; i <= n + 1; i++) {cin >> b[i];}for (int i = 1; i <= n; i++) {num += abs(a[i] - b[i]);sum = min(sum, abs(a[i] - b[n + 1]));sum = min(sum, abs(b[i] - b[n + 1]));}for (int i = 1; i <= n; i++) {if (a[i] > b[n + 1] && b[i] > b[n + 1] || a[i] < b[n + 1] && b[i] < b[n + 1])continue;else {flag = 1;}}if (flag == 1) {num += 1;}else {num += 1 + sum;}cout << num << endl;}return 0;
}

C. Job Interview

 

 思路:

从前往后遍历,检查一下是a能力值浪费了还是b能力值浪费了,然后从后往前枚举,开一个数组维护一下最近后缀损失能力值。输出答案的时候,如果当前的人的站的职位刚好是能力值被浪费的职位,输出总和减去当前的人的能力值加上最近损失能力值

实现代码:

#include<bits/stdc++.h>
using namespace std;
#define N 1000005
#define inf 1e9+7
typedef long long ll;
ll n, m, sum, ans, t, sum1, sum2, num1, num2, f;
ll q[N], p[N], a[N], b[N];
void solve()
{cin >> n >> m;sum1 = sum2 = num1 = num2 = f=0;for (int i = 0; i <= n+m; i++)cin >> a[i], q[i] = p[i] = 0;for (int i = 0; i <= n+m; i++) {cin >> b[i], f += a[i] > b[i];if (a[i] > b[i] && num1 <= n || m == i - num1)num1++, sum1 += a[i], p[i] = 1; else sum1 += b[i];if (a[i] < b[i] && num2 <= m || n == i - num2)num2++, sum2 += b[i], q[i] = 1; else sum2 += a[i];}for (int i = 0; i <= n+m; i++, cout << ' ')cout << (f > n ? (p[i] ? sum1 - a[i] : sum2 - b[i]) : (q[i] ? sum2 - b[i] : sum1 - a[i]));/*if (f > n) {if (p[i])cout << sum1 - a[i] << ' ';elsecout << sum2 - b[i] << ' ';}else {if (q[i])cout << sum1 - b[i] << ' ';elsecout << sum2 - a[i] << ' ';}*/
}
int main()
{cin >> t;while (t--) {solve();}
}

这篇关于Educational Codeforces Round 166 (Rated for Div. 2) (A~C)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1025782

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There